/*
 *	dlm.h			html converter for DoCoMo DataLinkSoftware(D208)
 *										Copyright(C)2000 By Kashi.
 *		2000/02/09	first edition
 */

struct melody	{
	char	number[2];		/* song number(ascii char) */
	short	dummy0;
	char	name[30];		/* song name(ascii, SJIS) */
	char	dummy1[26];
	char	memo[40];		/* song memo(ascii, SJIS) */
	char	tempo;			/* tempo. 84, 94, 108, 126, 150, 188bpm */
	char	dummy2[11];		/*     0x12, 0x10, 0x0e, 0x0c, 0x0a, 0x08 */
	char	toneflag1;		/* toneflag1 toneflag2 */
	char	dummy3[3];		/*     0         0     = tone A */
	char	toneflag2;		/*     1         0     = tone B */
	char	dummy4[15];		/*     1         1     = tone C */
	short	maxsize;		/* song length, 1/4 = 0x04, 1/1 = 0x10 */
	char	dummy5[6];		/* full size = 0x100 */
	char	sharps;			/* b0:C#, b1:D#..F#, G#, A# */
	char	flats;			/* b0:D-, b1:E-..G-, A-, B- */
	char	beat;			/* 0x10: 4/4, 0x0c:3/4, 0x08:2/2 */
	char	dummy6;
/* the tones written with 2 bytes per step.
 * first byte: tone data
 *		bit0-2:	tone value, 0:r, 1-7:C to B
 *		bit3:	sharp flag
 *		bit4:	flat flag
 *		bit5-7:	octave, 0: oct1, 4: oct5
 *
 * second byte: tone attribute
 *		0x80:	voice start
 *		0x40:	voice end
 *		0x00:	voice continue(tie)
 *		0xc0:	voice start/end(1 step)
 *
 * example:
 *		MML: o3c4d4c16d16
 *data(hex): 21 80 21 00 21 00 21 40	c4
 *			 22 80 22 00 22 00 22 40	d4
 *			 21 c0						c16
 *			 22 c0						d16
 */
	unsigned char	datas[3][512];		/* melody data */
	char	vol[3];						/* 01 = high, 02 = midium, 03 = low */
	char	delflag;					/* 00 = deleted, 0x10 = data available */
};

struct dlm	{
	char	header[8];		/* header string "ްݸ" */
	char	version[8];		/* version string "D0031.00" */
	short	unknown;
	char	dummy[14];

	struct	melody	melodies[20];
};

